<?php
/*******************************************************
Trovate questo e altri script su http://www.manuelmarangoni.it , descritti e commentati nei dettagli.

Autore: Manuel Marangoni
Data messa online dello script: 2 febbraio 2012

Lo script mostra come comporre una barra di navigazione il cui livello di profondità non deve avere un limite imposto.
Nell’esempio le categorie e le sottocategorie sono prese dal database e hanno una struttura gerarchica molto semplice: la sottocategoria avrà come riferimento, in un campo, l’id della categoria padre. Lo script però è facilmente modificabile in modo da prendere categorie scritte staticamente su un file.
*******************************************************/ 

include("config.inc.php"); //connessione al database

$http="http://www.sito.it/"; //indirizzo base del sito: da modificare (può essere lasciato vuoto)
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

<link rel="stylesheet" type="text/css" href="style.css">

<title>Esempio di sidebar - Elenco di categorie con sottocategorie</title>
</head>

<body>


<h1>Esempio di sidebar - Elenco di categorie con sottocategorie</h1>

<h2>Trovi questo e altri script su <a href="http://www.manuelmarangoni.it/">www.manuelmarangoni.it</a></h2>

<div id="descrizione">Cliccare sulle categorie per aprirle ed elencare le loro sottocategorie</div>

<div id="navigation">

<?php
//cerco i padri della sezione corrente e vedo se questa categoria è uno dei padri
$padri=array();
if(isset($_GET['id'])){
	$padri_stringa=cerca_padri($_GET['id']);
	$padri_stringa=trim($padri_stringa, "-"); //toglie l'ultimo carattere separatore
	$padri=explode("-", $padri_stringa); //immagazzino i singoli id padri in un array
}


/* Stampo le sezioni principali */
$query=mysql_query("select * from categorie where padre=0 order by nome", $db);
while($row=mysql_fetch_array($query)){	
	
	//valuto se la categoria è attiva
	//è attiva se siamo all'interno della categoria o in una delle sue sottocategorie
	$attivo=false;
	if( (isset($_GET["id"])) and ( ($_GET["id"]==$row["id"]) or (sizeof($padri)>0 and in_array($row['id'], $padri) ) ) )
		$attivo=true;
	
	//se la variabile $_GET['id'] è settata e corrisponde all'id della categoria, aggiungo la classe per renderla attiva
	?>
    <div class="sezione <?php if($attivo) echo "attivo";?>"><a href="<?php echo $http;?>index.php?id=<?php echo $row["id"];?>"><?php echo ucfirst($row["nome"]);?></a></div>
    
    <?php	
	if($attivo)
		echo menu_navigazione($row["id"],0);
    	
}



/*
* Cerca ricorsivamente i padri della categoria passata, spingendosi fino alla categoria principale
*/
function cerca_padri($id){
	global $db;
	
	$variabile=""; //immagazzino gli id dei padri in questa stringa, separandoli con il carattere "-"
	
	$query=mysql_query("select * from categorie where id=".$id." order by nome", $db);
	$row=mysql_fetch_array($query);
	if($row['padre']!=0){
		$variabile.=$row['padre']."-";
		$variabile.=cerca_padri($row['padre']);
	}
	
	return $variabile;
}


/*
* Funzione che stampa le sottocategorie della categoria che ha l'id passato come parametro
* In ordine i parametri passati sono: l'id della categoria padre; il livello di profondità della categoria padre
*/
function menu_navigazione($id, $livello){
	
	global $http, $db, $padri;
	$livello++; //la sottocategoria ha profondità del padre +1
	
	//Indentazione delle sezioni in base al livello (riduco di conseguenza la lunghezza del div)
	$spazio=0;
	for($i=0; $i<$livello; $i++)
		$spazio+=10;
	$width=210-$spazio;
	
	
	$variabile="";

	$query=mysql_query("select * from categorie where padre=".$id." order by nome", $db);
	if(mysql_num_rows($query)>0){
		while($row=mysql_fetch_array($query)){
			
			//valuto se la categoria è attiva
			//è attiva se siamo all'interno della categoria o in una delle sue sottocategorie
			$attivo=false;
			if( (isset($_GET["id"])) and ( ($_GET["id"]==$row["id"]) or (sizeof($padri)>0 and in_array($row['id'], $padri) ) ) )
				$attivo=true;
			
			$variabile.="<div class=\"sottosezione"; 
			if($attivo) $variabile.=" attivo";
			$variabile.="\" style=\"padding-left:".$spazio."px; width:".$width."px\"><a href=\"".$http."index.php?id=".$row["id"]."\">".ucfirst($row["nome"])."</a></div>";
			
			//reitero la funzione per cercare eventuali sottocategorie a questa sottocategoria
			if($attivo)
				$variabile.=menu_navigazione($row["id"],$livello);
		}
	}
	
	return $variabile;
}
?>


</div> <!-- navigation -->
<div class="clear"></div>

</body>
</html>
